###################################################
### chunk number 1: 
###################################################
#line 25 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
## Sets display options
options(width = 75, digits = 2, scipen = 5)

library(portfolioSim)


###################################################
### chunk number 2: 
###################################################
#line 125 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
data.frame(id = c("A", "B", "C"), shares = c(10, 20, -10))


###################################################
### chunk number 3: 
###################################################
#line 141 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
data.frame(id = c("B","C","D","E"), side=c("S","C","B","X"), shares=c(20,5,10,20))


###################################################
### chunk number 4: 
###################################################
#line 148 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
data.frame(id=c("A","C","D","E"), shares=c(10,-5,10,-20))


###################################################
### chunk number 5: 
###################################################
#line 258 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"

library(portfolioSim)

sdi <- new("sdiDf", data = data.frame(period = c(rep(1, times=4),
                                                 rep(2, times=4),
                                                 rep(3, times=4),
                                                 rep(4, times=4)),
                                      id = rep(c("A","B","C","D"), times=4)))
sdi@data$id <- as.character(sdi@data$id)
sdi@data$ret <- 0
sdi@data$start.price <- 10
sdi@data$end.price <- 10
sdi@data$volume <- 100
sdi@data$universe <- TRUE
sdi@data$universe[15] <- FALSE

trades.1 <- new("trades", trades = data.frame(id = c("A","B"),
                                              side = c("B","X"),
                                              shares = c(10,10)))
trades.2 <- new("trades", trades = data.frame(id = c("B","C","A","A"),
                                              side = c("C","B","X","S"),
                                              shares = c(5,5,10,10)))
trades.3 <- new("trades", trades = data.frame(id = c("B","D"),
                                              side = c("C","B"),
                                              shares = c(5,20)))
trades.4 <- new("trades", trades = data.frame(id = c("D"),
                                              side = c("B"),
                                              shares = c(5)))

sti <- new("stiPresetTrades", periods = c(1,2,3,4),
                              sim.trades = list(trades.1, trades.2,
                                                trades.3, trades.4))

periods <- data.frame(period = c(1,2,3,4), start = c(1,2,3,4), end = c(1,2,3,4))

ps <- new("portfolioSim", periods = periods, data.interface = sdi,
          trades.interface = sti, out.loc = "out_dir_1",
          out.type = c("portfolio","trades","basic"))

sim.portfolios <- runSim(ps, verbose = FALSE)



###################################################
### chunk number 6: 
###################################################
#line 313 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
getSimData(ps@data.interface, period = 1, verbose = FALSE)@data


###################################################
### chunk number 7: 
###################################################
#line 321 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
getSimTrades(ps@trades.interface, period = 1, holdings = new("portfolio"),
             sim.data = new("simData"), verbose = FALSE)@trades@trades


###################################################
### chunk number 8: 
###################################################
#line 332 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
sim.portfolios@data[[1]]@end.data@holdings@shares


###################################################
### chunk number 9: 
###################################################
#line 341 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
getSimTrades(ps@trades.interface, period = 2, holdings = new("portfolio"),
             sim.data = new("simData"), verbose = FALSE)@trades@trades


###################################################
### chunk number 10: 
###################################################
#line 353 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
sim.portfolios@data[[2]]@end.data@holdings@shares


###################################################
### chunk number 11: 
###################################################
#line 360 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
getSimTrades(ps@trades.interface, period = 3, holdings = new("portfolio"),
             sim.data = new("simData"), verbose = FALSE)@trades@trades


###################################################
### chunk number 12: 
###################################################
#line 371 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
sim.portfolios@data[[3]]@end.data@holdings@shares


###################################################
### chunk number 13: 
###################################################
#line 384 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
getSimTrades(ps@trades.interface, period = 4, holdings = new("portfolio"),
             sim.data = new("simData"), verbose = FALSE)@trades@trades


###################################################
### chunk number 14: 
###################################################
#line 392 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
getSimData(ps@data.interface, period = 4, verbose = FALSE)@data


###################################################
### chunk number 15: 
###################################################
#line 402 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
sim.portfolios@data[[4]]@start.data@holdings@shares


###################################################
### chunk number 16: 
###################################################
#line 409 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
sim.portfolios@data[[4]]@end.data@holdings@shares


###################################################
### chunk number 17: 
###################################################
#line 456 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
data.frame(period = 1:4,
start = as.POSIXct(c("2006-01-01 09:30", "2006-04-01 09:30", "2006-07-01 09:30", "2006-10-01 09:30")),
end = as.POSIXct(c("2006-03-31 16:00", "2006-06-30 16:00", "2006-09-30 16:00", "2006-12-31 16:00")))


###################################################
### chunk number 18: 
###################################################
#line 861 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
data(starmine.sim)
names(starmine.sim)


###################################################
### chunk number 19: 
###################################################
#line 870 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
periods <- data.frame(period = sort(starmine.sim$date[!duplicated(starmine.sim$date)]))
## periods <- data.frame(period = unique(starmine.sim$date))
periods$start <- periods$period
periods$end <- c(periods$start[-1], as.Date("1995-12-31"))

periods


###################################################
### chunk number 20: 
###################################################
#line 905 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
starmine.sim$period <- starmine.sim$date


###################################################
### chunk number 21: 
###################################################
#line 919 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
starmine.sim$start.price <- starmine.sim$prior.close.usd
starmine.sim$end.price <- starmine.sim$price.usd


###################################################
### chunk number 22: 
###################################################
#line 941 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
starmine.sim$ret <- starmine.sim$ret.1m


###################################################
### chunk number 23: 
###################################################
#line 953 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
starmine.sim$universe <- TRUE


###################################################
### chunk number 24: 
###################################################
#line 961 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
data.interface <- new("sdiDf", data = starmine.sim)


###################################################
### chunk number 25: 
###################################################
#line 987 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
trades.interface <- new("stiFromSignal", in.var = "smi",
size = "decile", equity = 1000000, rebal.on = periods$period)


###################################################
### chunk number 26: 
###################################################
#line 1006 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
ps <- new("portfolioSim", periods = periods, freq = 12,
data.interface = data.interface, trades.interface = trades.interface,
fill.volume.pct = Inf, out.loc = "out_dir_2", out.type = "lean")


###################################################
### chunk number 27: 
###################################################
#line 1027 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
result <- runSim(ps, verbose = FALSE)


###################################################
### chunk number 28: 
###################################################
#line 1048 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
summary(result)


###################################################
### chunk number 29: 
###################################################
#line 1069 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
ps@out.type <- "detail"
result <- runSim(ps, verbose = FALSE)


###################################################
### chunk number 30: 
###################################################
#line 1074 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
summary(result)


###################################################
### chunk number 31: 
###################################################
#line 1082 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
result <- loadIn(new("simResult"), in.loc = "out_dir_2")


###################################################
### chunk number 32: 
###################################################
#line 1157 "d:/Rcompile/CRANpkg/local/2.12/portfolioSim/inst/doc/portfolioSim.Rnw"
unlink("out_dir_1", recursive = TRUE)
unlink("out_dir_2", recursive = TRUE)


